Pose0:
    push    r4,r14
    ldr     r4,=CurrSpriteData
	; new code to check item collected
	ldrb    r0,[r4,1Dh]
	bl      CheckCollected
	cmp     r0,0h
	beq     @@Initialize
	mov     r0,0h
	strh    r0,[r4]			; remove sprite
	b       @@Return
	; end of new code
@@Initialize:
	ldrh    r1,[r4]
    ldr     r0,=0FFFBh
    and     r0,r1
    mov     r2,0h
    mov     r3,0h
    strh    r0,[r4]			; status &= FFFB
	; new code to adjust height
	ldrh    r0,[r4,2h]
	sub     r0,20h
	strh    r0,[r4,2h]
	; end of new code
    ldr     r1,=0FFE4h
    strh    r1,[r4,0Ah]		; top boundary = FFE4
    mov     r0,1Ch
    strh    r0,[r4,0Ch]		; bottom boundary = 1C
    strh    r1,[r4,0Eh]		; left boundary = FFE4
    strh    r0,[r4,10h]		; right boundary = 1C
    mov     r0,r4
    add     r0,27h
    mov     r1,0Ch
    strb    r1,[r0]			; sprite[27] = C
    add     r0,1h
    strb    r1,[r0]			; sprite[28] = C
    add     r0,1h
    strb    r1,[r0]			; sprite[29] = C
    strb    r2,[r4,1Ch]		; animation counter = 0
    strh    r3,[r4,16h]		; animation = 0
	mov     r0,1h
    strh    r0,[r4,14h]		; health = 1
	ldr     r2,=PrimarySpriteStats 	                  
	ldrb    r1,[r4,1Dh]				;sprite ID                    
	lsl     r0,r1,3h                       
	sub     r0,r0,r1                       
	lsl     r0,r0,1h                       
	add     r0,r0,r2                       
	ldrh    r0,[r0]					;sprite health
	mov     r1,r4
    add     r1,24h	
	cmp		r0,0h
	bne		@@PreventBall
	mov		r0,1h
	strb	r0,[r1,1h]			;makes sprite solid
	mov		r0,8h
	strb	r0,[r1]				;pose = 8
    ldr		r0,=ItemOrbOAM
	str		r0,[r4,18h]
	b		@@Return
@@PreventBall:
	mov		r0,9h
	strb	r0,[r1]				;pose = 9
	mov		r0,0Ch
	strb	r0,[r1,1h]			;ability collision
	mov		r2,r4
	add     r2,34h
    ldrb    r1,[r2]
    mov     r0,40h
    orr     r0,r1
    strb    r0,[r2]				;makes sprite immune to projectiles
	mov		r0,r4
	;add     r0,20h
    ;ldrb    r1,[r0]
    ;sub		r1,1h
    ;strb    r1,[r0]				;changes sprite palette
    ldr		r0,=ItemExposedOAM
	str		r0,[r4,18h]
@@Return:
    pop     r4
    pop     r0
    bx      r0
.pool
	
Pose8:
	ldr		r3,=CurrSpriteData
	mov		r0,r3
	add		r0,34h
	ldrb	r1,[r0]
	mov		r2,10h
	and		r1,r2		;true if sprite is shot
	cmp		r1,0h
	beq		@@Return
	eor		r1,r2
	strb	r1,[r0]
	mov		r1,1h
	strh	r1,[r3,14h]
	sub		r0,10h
	mov		r1,25h
	strb	r1,[r0]		;set pose 25
@@Return:
    bx      r14
	
PoseDefault:
    push    r4,r14
    ldr     r4,=CurrSpriteData
    mov     r2,r4
    add     r2,34h
    ldrb    r1,[r2]
    mov     r0,40h
    mov     r3,0h
    orr     r0,r1
    strb    r0,[r2]			; sprite[32] |= 40
    mov     r2,0h
    mov     r0,1h
    mov     r1,r4
    strh    r0,[r1,14h]		; health = 1
    add     r1,26h
	strb	r0,[r1]			;sprite[26] = 1
	sub		r1,1h
    mov     r0,0Fh			;?????
    strb    r0,[r1]			; sprite[25] = 0Fh
    sub     r1,1h
    mov     r0,30h
    strb    r0,[r1]			; pose = 30
	add		r0,2h
    mov     r0,r4
    strb    r2,[r0,1Ch]		; animation counter = 0
    strh    r3,[r0,16h]		; animation = 0
    ;add     r0,20h
    ;ldrb    r1,[r0]
   ; sub     r1,1h
    ;strb    r1,[r0]			; collision -= 14
    mov     r2,r4
    add     r2,2Ch
    ldrb    r1,[r2]
    mov     r0,0h
    strb    r0,[r2]			; sprite[2C] &= 80
    ; use own sprite ID
    ldr		r0,=ItemShotOAM
	str		r0,[r4,18h]
    mov     r0,66h
	lsl		r0,r0,2h		;sound for breaking orb
    bl      PlaySound
	pop		r4
    pop     r0
    bx      r0
.pool
	
	
Pose30:
    push    r14
    bl      CheckEndSpriteAnimation
    cmp     r0,0h
    beq     @@Return
    ldr     r1,=CurrSpriteData
    mov     r3,r1
    add     r3,24h
    mov     r2,0h
    mov     r0,9h
    strb    r0,[r3]			; pose = 9
    strb    r2,[r1,1Ch]		; animation counter = 0
    strh    r2,[r1,16h]		; animation = 0
    ; use own sprite ID
    ldr		r0,=ItemExposedOAM
	str		r0,[r1,18h]
@@Return:
    pop     r0
    bx      r0
    .pool
	
	
Pose9:
    push    r4,r14
    ldr     r3,=CurrSpriteData
    ldrh    r1,[r3]
    mov     r0,80h
    lsl     r0,r0,4h
    and     r0,r1
    cmp     r0,0h
	
    beq     @@Return		; return if status doesn't have 800
    ldr     r1,=FreezeWorld	; ???
    mov     r2,0FAh
    lsl     r2,r2,2h
    mov     r0,r2
    strh    r0,[r1]			;  = 3E8
    mov     r4,r3
    add     r4,34h
    ldrb    r1,[r4]
    mov     r0,1h
    mov     r2,0h
    orr     r0,r1
    strb    r0,[r4]			; freeze timer |= 1
    mov     r1,r3
    add     r1,26h
    mov     r0,1h
    strb    r0,[r1]			; sprite[26] = 1
    sub     r1,2h
    mov     r0,23h
    strb    r0,[r1]			; pose = 23
	; use own sprite ID
    ldrb    r4,[r3,1Dh]
    mov     r0,r4			; r0 = sprite ID
;    bl      SetChozoEvent
    mov     r0,r4			; r0 = sprite ID
    bl      GetItem
@@Return:
    pop     r4
    pop     r0
    bx      r0
    .pool

	
Pose23:
    push    r14
    ldr     r2,=CurrSpriteData
    mov     r1,r2
    add     r1,26h
    mov     r0,1h
    strb    r0,[r1]			; sprite[26] = 1
    add     r1,7h
    ldrb    r1,[r1]			; r1 = sprite[2D]
    and     r0,r1
    cmp     r0,0h
    bne     @@SkipToggle	; skip if sprite[2D] has 1
    ldrh    r0,[r2]
    mov     r1,4h
    eor     r0,r1
    strh    r0,[r2]			; status ^= 2
@@SkipToggle:
    ldr     r0,=FreezeWorld
    ldrh    r1,[r0]
	mov		r0,0h
    cmp     r1,r0
    bhi     @@Return		
    mov     r0,0h
    strh    r0,[r2]			; status = 0 (remove sprite)
@@Return:
    pop     r0
    bx      r0
    .pool

GetItem:				;because Fusion's message box xystem is retarded, add 15h to every message box ID 
    push    r4,r14			;Otherwise the message wont be correct
    add     sp,-0Ch
	mov		r1,0h
	ldr		r2,=SamusEquipment
    cmp     r0,MorphID
    beq     @@MorphMessage
    cmp     r0,BombID
    beq     @@BombMessage
    cmp     r0,HiJumpID
    beq     @@HiJumpMessage
    cmp     r0,SpeedID
    beq     @@SpeedMessage
    cmp     r0,VariaID
    beq     @@VariaMessage
    cmp     r0,GravityID
    beq     @@GravityMessage
    cmp     r0,SpaceJumpID
    beq     @@SJMessage
    cmp     r0,ScrewID
    beq     @@ScrewMessage
    cmp     r0,ChargeID
    beq     @@ChargeMessage
    cmp     r0,WideID
    beq     @@WideMessage
    cmp     r0,IceID
    beq     @@IceMessage
	cmp		r0,WaveID
	beq		@@WaveMessage
	cmp		r0,PlasmaID
	beq		@@PlasmaMessage
	cmp		r0,SuperID
	beq		@@SuperMessage
	cmp		r0,IceMissileID
	beq		@@IceRocketMessage
	cmp		r0,DiffusionID
	beq		@@DiffusionMessage
    b       @@DisplayMessage
@@SuperMessage:
	mov		r3,02h
	mov		r1,1Ah
	b 		@@SetMissile
@@BombMessage:
	mov		r3,10h
    mov     r1,1Bh
    b       @@SetMissile
@@IceRocketMessage:
	mov		r3,4h
	mov		r1,1Dh
	b 		@@SetMissile
@@DiffusionMessage:
	mov		r3,8h
	mov		r1,1Eh
	b 		@@SetMissile
@@MorphMessage:
	mov		r3,40h
    mov     r1,1Fh
    b       @@SetSuitMisc
@@HiJumpMessage:
	mov		r3,1h
    mov     r1,20h
    b       @@SetSuitMisc
@@ScrewMessage:
	mov		r3,8h
    mov     r1,21h
    b       @@SetSuitMisc
@@SJMessage:
	mov		r3,4h
    mov     r1,22h
	b		@@SetSuitMisc
@@SpeedMessage:
	mov		r3,2h
    mov     r1,23h
    b       @@SetSuitMisc
@@VariaMessage:
	mov		r3,10h
    mov     r1,24h
    b       @@SetSuitMisc
@@GravityMessage:
	mov		r3,20h
    mov     r1,25h
    b       @@SetSuitMisc
@@ChargeMessage:
	mov		r3,1h
    mov     r1,26h
    b       @@SetBeam
@@WideMessage:
	mov		r3,2h
    mov     r1,27h
    b       @@SetBeam
@@WaveMessage:
	mov		r3,8h
	mov		r1,28h
	b		@@SetBeam
@@PlasmaMessage:
	mov		r3,4h
	mov		r1,29h
	b 		@@SetBeam
@@IceMessage:
	mov		r3,10h
    mov     r1,2Ah
	b 		@@SetBeam
@@SetMissile:
	ldrb	r0,[r2,0Bh]			;activate bombs
	orr		r0,r3
	strb	r0,[r2,0Bh]
	b 		@@DisplayMessage
@@SetBeam:
	ldrb	r0,[r2,0Ah]
	orr		r0,r3
	strb	r0,[r2,0Ah]		;activating beam related item
	mov		r4,r1
	bl		LoadBeamGFX
	mov		r1,r4
	b 		@@DisplayMessage
@@SetSuitMisc:
	ldrb	r0,[r2,0Ch]		;activating suit related item
	orr		r0,r3	
	strb	r0,[r2,0Ch]
@@DisplayMessage:
    ldr     r0,=CurrSpriteData
    ldrh    r2,[r0,2h]
	str		r2,[sp]
    ldrh    r0,[r0,4h]
    str     r0,[sp,4h]
    mov     r0,0h
    str     r0,[sp,8h]
    mov     r0,21h
    mov     r2,6h
	mov		r3,10h
    bl      SpawnNewPrimarySprite
    add     sp,0Ch
	pop		r4
    pop     r0
    bx      r0
.pool

CheckCollected:
	ldr		r1,=SamusEquipment
	mov		r2,0h
	cmp     r0,MorphID
    beq     @@MorphCheck
    cmp     r0,BombID
    beq     @@BombCheck
    cmp     r0,HiJumpID
    beq     @@HiJumpCheck
    cmp     r0,SpeedID
    beq     @@SpeedCheck
    cmp     r0,VariaID
    beq     @@VariaCheck
    cmp     r0,GravityID
    beq     @@GravityCheck
    cmp     r0,SpaceJumpID
    beq     @@SJCheck
    cmp     r0,ScrewID
    beq     @@ScrewCheck
    cmp     r0,ChargeID
    beq     @@ChargeCheck
    cmp     r0,WideID
    beq     @@WideCheck
    cmp     r0,IceID
    beq     @@IceCheck
	cmp		r0,WaveID
	beq		@@WaveCheck
	cmp		r0,PlasmaID
	beq		@@PlasmaCheck
	cmp		r0,SuperID
	beq		@@SuperCheck
	cmp		r0,IceMissileID
	beq		@@IceMissileCheck
	cmp		r0,DiffusionID
	beq		@@DiffusionCheck
    b       @@CheckActive
@@SuperCheck:
	mov		r2,2h
	b 		@@CheckMissile
@@BombCheck:
	mov		r2,10h
    b       @@CheckMissile
@@IceMissileCheck:
	mov		r2,4h
	b 		@@CheckMissile
@@DiffusionCheck:
	mov		r2,8h
	b 		@@CheckMissile
@@MorphCheck:
	mov		r2,40h
    b       @@CheckSuitMisc
@@HiJumpCheck:
	mov		r2,1h
    b       @@CheckSuitMisc
@@ScrewCheck:
	mov		r2,8h
    b       @@CheckSuitMisc
@@SJCheck:
	mov		r2,4h
	b		@@CheckSuitMisc
@@SpeedCheck:
	mov		r2,2h
    b       @@CheckSuitMisc
@@VariaCheck:
	mov		r2,10h
    b       @@CheckSuitMisc
@@GravityCheck:
	mov		r2,20h
    b       @@CheckSuitMisc
@@ChargeCheck:
	mov		r2,1h
    b       @@CheckBeam
@@WideCheck:
	mov		r2,2h
    b       @@CheckBeam
@@WaveCheck:
	mov		r2,8h
	b		@@CheckBeam
@@PlasmaCheck:
	mov		r2,4h
	b 		@@CheckBeam
@@IceCheck:
	mov		r2,10h
	b 		@@CheckBeam
@@CheckMissile:
	ldrb	r0,[r1,0Bh]
	b 		@@CheckActive
@@CheckBeam:
	ldrb	r0,[r1,0Ah]
	b 		@@CheckActive
@@CheckSuitMisc:
	ldrb	r0,[r1,0Ch]
@@CheckActive:
	and		r0,r2
	cmp		r0,0h
	beq		@@Return
	mov		r1,1h
@@Return:
	bx		r14
.pool

ChozoBallAI:
	push    r14
    ldr     r0,=CurrSpriteData
    add     r0,24h
    ldrb    r0,[r0]			; r0 = sprite pose
    cmp     r0,23h
    beq     @@Pose23
    cmp     r0,23h			
    bgt     @@Pose24_plus
    cmp     r0,8h
    beq     @@Pose8
    cmp     r0,8h
    bgt     @@Pose9_plus
    cmp     r0,0h
    beq     @@Pose0
    b       @@PoseDefault
@@Pose9_plus:
    cmp     r0,9h
    beq     @@Pose9
    b       @@PoseDefault
@@Pose24_plus:
    cmp     r0,30h
    beq     @@Pose30
    b       @@PoseDefault
@@Pose0:
    bl      Pose0
    b       @@Return
@@Pose8:
    bl      Pose8
    b       @@Return
@@Pose30:
    bl      Pose30
    b       @@Return
@@Pose9:
    bl      Pose9
    b       @@Return
@@Pose23:
	bl      Pose23
    b       @@Return
@@PoseDefault:
	bl      PoseDefault
@@Return:
    pop     r0
    bx      r0
	.pool