.gba
.open "mf.gba","ChozoBall2.gba",0x8000000

;Instructions: for any sprite you wish to not spawn in a ball
;make its health anything other than 0 in MAGE. Will not effect amount of shots
;it takes to open ball;

.definelabel MorphID,0x17
.definelabel BombID,0x33
.definelabel HiJumpID,0x35
.definelabel SpeedID,0x4A
.definelabel VariaID,0x4E
.definelabel SpaceJumpID,0x4F
.definelabel GravityID,0x50
.definelabel ScrewID,0x5D

.definelabel ChargeID,0x99
.definelabel WideID,0x9A
.definelabel IceID,0x9B
.definelabel WaveID,0x9C
.definelabel PlasmaID,0xC5

.definelabel SuperID,0x9D
.definelabel IceMissileID,0x9E
.definelabel DiffusionID,0x9F

.definelabel CurrSpriteData,0x30006BC
.definelabel SamusEquipment,0x3001310
.definelabel FreezeWorld,0x3001348

.definelabel PlaySoundCutMusic,0x80038A8
.definelabel PlaySound,0x8003B1C
.definelabel SpawnNewPrimarySprite,0x800FBC8
.definelabel LoadBeamGFX,0x8081E5C
.definelabel CheckEndSpriteAnimation,0x8011934
.definelabel PrimarySpriteStats,0x82E4D4C

.definelabel SpriteGFXLenghts,0x82E4A50
.definelabel SpriteAIPointers,0x879A29C
.definelabel SpriteGfxPointers,0x879A5D8
.definelabel SpritePalPointers,0x879A8D4

;.definelabel SetChozoEvent,0x80138D8


;file that sets all pointers and sprite data
.include "Fusion Items\SpriteSetup.asm"

.org 0x802A93A
	cmp		r0,18h
.org 0x80797F2 ;makes messages work???
	sub		r2,2Ah
	
.org 0x802AA62
	bl	CheckSoundToPlay
.org 0x802AB04
	bl	CheckTimerToSet
        strh            r0,[r1,6]
        add             r13,0ch


.org 0x80F9A28   ; unused sound sample
CheckSoundToPlay:
	push	r14
	cmp		r6,1Ah
	blt		@@NormalSound
	mov		r0,10h
	bl		PlaySoundCutMusic
	b		@@Return
@@NormalSound:
	bl 		PlaySound
@@Return:
	pop		r0
	bx		r0
	
CheckTimerToSet:
        ldr             r1,=30006bch
	cmp		r6,1Ah
	blt		@@NormalTimer
	mov		r0,0BEh
	lsl		r0,r0,1h	;timer for item messages
	b		@@Return
@@NormalTimer:
	mov		r0,5Ah ;timer for other messages
@@Return:
	bx		r14	
	
.include "Fusion Items\MFItemAI.asm"  ;item ball ai
	
.org 0x879ECD0  ;freespace
	.include "Fusion Items\itemOAM.asm"
	.align
ChargeBeamGFX:
	.import "Fusion Items\MFItemGFX\Charge B.gfx"
	.align
WideBeamGFX:
	.import "Fusion Items\MFItemGFX\Wide B.gfx"
	.align
IceBeamGFX:	
	.import "Fusion Items\MFItemGFX\Ice B.gfx"
	.align
WaveBeamGFX:
	.import "Fusion Items\MFItemGFX\Wave B.gfx"
	.align
MorphballGFX:
	.import "Fusion Items\MFItemGFX\Morph.gfx"
	.align
BombGFX:
	.import "Fusion Items\MFItemGFX\Bombs.gfx"
	.align
SpeedBoosterGFX:
	.import "Fusion Items\MFItemGFX\Speed.gfx"
	.align
HiJumpGFX:
	.import "Fusion Items\MFItemGFX\Hi-Jump.gfx"
	.align
ScrewattackGFX:
	.import "Fusion Items\MFItemGFX\Screw.gfx"
	.align
VariaSuitGFX:
	.import "Fusion Items\MFItemGFX\Varia.gfx"
	.align
GravitySuitGFX:
	.import "Fusion Items\MFItemGFX\Gravity.gfx"
	.align
SpaceJumpGFX:
	.import "Fusion Items\MFItemGFX\Space Jump.gfx"
	.align
PlasmaBeamGFX:
	.import "Fusion Items\MFItemGFX\Plasma B.gfx"
	.align
IceMissileGFX:
	.import "Fusion Items\MFItemGFX\Ice M.gfx"
	.align
SuperMissileGFX:
	.import "Fusion Items\MFItemGFX\Super M.gfx"
	.align
DiffusionMissileGFX:
	.import "Fusion Items\MFItemGFX\Diffusion M.gfx"
	.align
MorphBallPal:
	.import "Fusion Items\MFItemGFX\Morph.palette"
	.align
BombPal:
	.import "Fusion Items\MFItemGFX\Bomb.palette"
	.align
SpeedBoosterPal:
	.import "Fusion Items\MFItemGFX\Speed.palette"
	.align
HiJumpPal:
	.import "Fusion Items\MFItemGFX\HiJump.palette"
	.align
VariaSuitPal:
	.import "Fusion Items\MFItemGFX\Varia.palette"
	.align
GravitySuitPal:
	.import "Fusion Items\MFItemGFX\gravity.palette"
	.align
ScrewAttackPal:
	.import "Fusion Items\MFItemGFX\screw.palette"
	.align
SpaceJumpPal:
	.import "Fusion Items\MFItemGFX\space.palette"
	.align	
ChargeBeamPal:
	.import "Fusion Items\MFItemGFX\Charge.palette"
	.align
WideBeamPal:
	.import "Fusion Items\MFItemGFX\Wide.palette"
	.align
WaveBeamPal:
	.import "Fusion Items\MFItemGFX\Wave.palette"
	.align
IceBeamPal:
	.import "Fusion Items\MFItemGFX\Ice.palette"
	.align
PlasmaBeamPal:
	.import "Fusion Items\MFItemGFX\plasma.palette"
	.align
SuperMissilePal:
	.import "Fusion Items\MFItemGFX\Super.palette"
	.align
IceMissilePal:
	.import "Fusion Items\MFItemGFX\Ice M.palette"
	.align
DiffusionMissilePal:
	.import "Fusion Items\MFItemGFX\Diffusion.palette"
	.align

.close